#[doc = "Register `OSCLK_DR0` reader"]
pub struct R(crate::R<OSCLK_DR0_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<OSCLK_DR0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<OSCLK_DR0_SPEC>> for R {
    fn from(reader: crate::R<OSCLK_DR0_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `OSCLK_DR0` writer"]
pub struct W(crate::W<OSCLK_DR0_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<OSCLK_DR0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<OSCLK_DR0_SPEC>> for W {
    fn from(writer: crate::W<OSCLK_DR0_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ADDER` reader - These bits return the lower 8 bits of the oscillator locking circuits adder output."]
pub struct ADDER_R(crate::FieldReader<u8, u8>);
impl ADDER_R {
    pub(crate) fn new(bits: u8) -> Self {
        ADDER_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ADDER_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:7 - These bits return the lower 8 bits of the oscillator locking circuits adder output."]
    #[inline(always)]
    pub fn adder(&self) -> ADDER_R {
        ADDER_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Oscillator lock data register 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [osclk_dr0](index.html) module"]
pub struct OSCLK_DR0_SPEC;
impl crate::RegisterSpec for OSCLK_DR0_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [osclk_dr0::R](R) reader structure"]
impl crate::Readable for OSCLK_DR0_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [osclk_dr0::W](W) writer structure"]
impl crate::Writable for OSCLK_DR0_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets OSCLK_DR0 to value 0"]
impl crate::Resettable for OSCLK_DR0_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
